import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.logging.Logger;
/*
 * Created on 2008/04/27
 *
 * LbVt@C쐬pqvZXN邽߂̃Xbh
 */

public class KickCashFileProcess extends Thread {

	// Oo
	Logger logger;

	String myfilename;
	String execPath;
	
	private KickCashFileProcess() {
	}
	
	KickCashFileProcess(Logger p_logger, String xmlfile, String p_execPath) {
        this.logger = p_logger;
        myfilename = xmlfile;
        execPath = p_execPath;
    }

    public void run() {
        // compute primes larger than minPrime
		// 摜LbVt@C쐬vZXN 2008/4/26`
		if(myfilename==null){
			logger.warning("myfilename is null");
			return;
		}
		String[] cmdp= new String[6];
		Process process = null;
		try{
			File home = new File(execPath);
			cmdp[0] = "java";
			cmdp[1] = "-cp";
			cmdp[2] = "\""+home.getCanonicalPath() + File.separator+ "lib" + File.separator+"sbeditAccelerator.jar"+"\"";
			cmdp[3] = "sbeditAccelerator";
			cmdp[4] = "\""+myfilename+"\"";
			cmdp[5] = "\""+home.getCanonicalPath()+"\"";
			logger.info("qvZXN"+cmdp[0]+" "+cmdp[1]+" "+cmdp[2]+" "+cmdp[3]+" "+cmdp[4]+" "+cmdp[5]);
			process = Runtime.getRuntime().exec(cmdp);
			logger.info("qvZXN."+cmdp[0]+" "+cmdp[1]+" "+cmdp[2]+" "+cmdp[3]+" "+cmdp[4]+" "+cmdp[5]);
			
			/* 1 TuvZX̓̓Xg[擾 */
			InputStream in=null;
			InputStreamReader isr=null;
			BufferedReader br=null;
			try{
				//Thread.sleep(2000); // qvZX̏҂
				in  = process.getInputStream(); 
				//isr = new InputStreamReader(in);
				//br  = new BufferedReader(isr);
				//String line;
				logger.info("qvZX͑҂");
				int  c;
				while ( (c = in.read()) != -1){
					System.out.print((char)c);
				}
				/**
				while ((line = br.readLine()) != null) {
					System.out.println(line);
				}
				**/
		  	} catch (Exception e) {		
		  		logger.warning("qvZXʐMs@"+e.toString());
		  		e.printStackTrace();      	
		 	}finally{
		 		if(in != null)
			 		in.close();
		 		if(isr!=null)
		 			isr.close();
		 		if(br != null)
		 			br.close();
		 	}
		 	try{
			    process.waitFor();
			    logger.info("qvZXI҂waitA");
		 	}catch(InterruptedException ie){
		 		logger.warning(ie.toString());
		 	}
		}catch(IOException ee){
			ee.printStackTrace();
			logger.warning("sbeditAccelerator Ns ["+cmdp[0]+" "+cmdp[1]+" "+cmdp[2]+" "+cmdp[3]+" "+cmdp[4]+" "+cmdp[5]+"] G["+ee.toString() );
		}finally{
			logger.info("vZXImF");
		    if(process != null) {
		    	try{
			        process.getErrorStream().close();
		    	}catch(Exception ioe){
		    		logger.warning(ioe.toString());
		    	}
		    	try{
			        process.getInputStream().close();
		    	}catch(Exception ioe){
		    		logger.warning(ioe.toString());
		    	}
		    	try{
			        process.getOutputStream().close();
		    	}catch(Exception ioe){
		    		logger.warning(ioe.toString());
		    	}
		        process.destroy();
		        process = null;
		    }
		}
    }

}
