/*
 * Created on 2006/01/27
 *
 * iText.jar, iTextAsian.jar gPDFo
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Point;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.Hashtable;

import javax.imageio.ImageIO;
import javax.imageio.ImageReader;
import javax.swing.JLabel;
import javax.swing.SwingUtilities;

import com.lowagie.text.*;
import com.lowagie.text.pdf.BaseFont;

/**
 *
 * @author nekora@users.sourceforge.jp
 *
 * iText.jar, iTextAsian.jar gPDFo͂NX
 * http://www.ee.e-mansion.com/~egami/iText/
 */
abstract public class MakeiTextTemp extends MakeTemplate{

	java.awt.Font dfont;  // tHg
	java.awt.Font sfont;  // tHg
	Hashtable<String, ImageReader> imageReaders; // egqɑΉImageIO Reader

	MakeiTextTemp(String p_filename,  String p_path, SBDTableModel p_model, DialogProgress p_dlg,  java.awt.Font p_dfont, java.awt.Font p_sfont, Hashtable<String, ImageReader> p_imageReaders) {
		super( p_filename,  p_path,  p_model, p_dlg );
		dfont = p_dfont;
		sfont = p_sfont;
		imageReaders = p_imageReaders;
	}

	/**
     * t@Co͏{
	 * @see MakeTemplate#exec()
	 */
	@Override
	void exec() {
		/**
		 * 󔒉摜
		 */
		String blankimage = getBlankImageFileName();
		float iconhight = getBlankY();

		// DocumentIuWFNg̐
		// A4c
		// Document document = new Document(PageSize.A4);
		// A4
		// Document document = new Document(PageSize.A4.rotate());
		// łnj
		Document document = new Document();
		Table aTable;

		try {
			/* PDF,RTF,HTMLɉWriterIuWFNg̐ */
			getWriter(document);
			/**
			if (fileName.toLowerCase().indexOf(".pdf") > 0) {
				PdfWriter.getInstance(document, new FileOutputStream(fileName));
			}else if (fileName.toLowerCase().indexOf(".rtf") > 0) {
				RtfWriter.getInstance(document, new FileOutputStream(fileName));
			}else if (fileName.toLowerCase().indexOf(".htm") > 0) {
				HtmlWriter.getInstance(document, new FileOutputStream(fileName));
			}
			**/

			// Font ̎w iTextAsian.jar 𕹗p邱ƂKv
			// ̂ۂ̂Ȃȉݒ肵܂B
			BaseFont minchoF = BaseFont.createFont("HeiseiMin-W3",
					"UniJIS-UCS2-HW-H", false);

			// SVbNۂ̂Ȃȉ̐ݒɂ܂B
			BaseFont gothF = BaseFont.createFont("HeiseiKakuGo-W5",
             "UniJIS-UCS2-H",false);

			// ̑AWindowsMSSVbNgꍇ́Aȉ̂悤ɂ܂B
			// BaseFont bf =
            // BaseFont.createFont("c:\\winnt\\fonts\\msgothic.ttc,1",
			// BaseFont.IDENTITY_H, BaseFont.EMBEDDED);


			// wb_iSVbNj
			Font font = new Font(gothF, 12);

			/* ҂ƃ^Cg */
			document.addAuthor( model.getAuthor() );
			document.addTitle(model.getTitle());
			// addSubject( model.getTitle() ); // Tu^Cg
			document.addCreator("GReGfB^ by nekora");

			// o͂wb_B^Cgƃy[Wԍ
			HeaderFooter header = new HeaderFooter(new Phrase(
					model.getTitle()+"     y[W " , font), new Phrase("."));
			header.setAlignment(Element.ALIGN_LEFT );
			document.setHeader(header);
			/* tb^ȂB
			HeaderFooter footer = new HeaderFooter(new Phrase("y[W ", font),
					new Phrase("."));

			footer.setAlignment(Element.ALIGN_CENTER);
			document.setFooter(footer);
			*/

			/* hLgOPEN */
			document.open();

			/* Rec̋Lq */


			// ĔԍAbiSVbNj
			Font fontk = new Font(gothF, 10);

			// ()
			Font fontd;
			if(dfont == null){
				fontd = new Font(minchoF, 9);
			}else{
				logger.info("dfont.size="+ dfont.getSize() );
				fontd = new Font(minchoF, dfont.getSize()  );
			}
			// 䎌()
			Font fonts;
			if(sfont == null){
				fonts = new Font(minchoF, 9);
			}else{
				logger.info("sfont.size="+ sfont.getSize() );
				fonts = new Font(minchoF, sfont.getSize() );
			}

			// 1y[Wڃ^Cg
			//Paragraph para = new Paragraph(model.getTitle()  , font);
			//para.setAlignment(Element.ALIGN_CENTER);
			//document.add(para);

			aTable = new Table(6); // e[uEIuWFNg̐
			aTable.setDefaultHorizontalAlignment(Element.ALIGN_CENTER);
			aTable.setDefaultVerticalAlignment(Element.ALIGN_MIDDLE);
			aTable.setPadding(2);

			setTableWidth(aTable);
			Cell[] col = new Cell[6];
			col[0] = new Cell(new Phrase("", font));
			col[1] = new Cell(new Phrase("", font));
			col[2] = new Cell(new Phrase("", font));
			col[3] = new Cell(new Phrase("䎌", font));
			col[4] = new Cell(new Phrase("b", font));
			col[5] = new Cell(new Phrase("v", font));
			for(int i=0; i< col.length; i++){
				aTable.addCell(col[i]); // J
			}
			/**
			aTable.addCell(col[0]); // J
			aTable.addCell("Image"); // J
			aTable.addCell("Desc"); // J
			aTable.addCell("Sound"); // J
			aTable.addCell("Sec"); // J
			aTable.addCell("Total"); // J
			**/
			aTable.endHeaders(); // ł܂ĂJ\
			aTable.setCellsFitPage(true); // y[Wɂ܂ăZ񕪊Ȃ

			// ̃[v͍s
			for (int i = 0; i < model.getRowCount()  ; i++) {
				// CXbh̎wŋI
				if(lock.getState() == false ){
					logger.warning("CXbh̎wiTexto͒f");
					break;
				}
				Cell cell;
				cell = new Cell(new Phrase((String)model.getValueAt(i, 0).toString(), fontk) ) ; // mD
				aTable.addCell(cell); // Jbgm

				Image img=null;
				try{
					String imgname=model.getImgNameAt(i);
					logger.info(model.getImgNameAt(i));
					if (imgname == null || imgname.length() <= 0) {
						// 󔒃C[W
						img = Image.getInstance(blankimage);
					} else {
						img = Image.getInstance(imgname);
						logger.info("X=" + img.plainWidth() + " Y="
								+ img.plainHeight());
						if (img.plainHeight()  != iconhight ) {
							// TCY
							img = getScaledImage(imgname);
							logger.info("CHANGE X=" + img.plainWidth() + " Y="
									+ img.plainHeight());
						}
					}
				}catch(Exception e){
					e.printStackTrace();
					logger.warning( e.toString() );
					img = Image.getInstance(blankimage);
				}
				cell = new Cell(img);
				aTable.addCell(cell); // G

				cell = new Cell(new Phrase((String)model.getValueAt(i, 2) , fontd));   // 
				cell.setHorizontalAlignment(ElementTags.ALIGN_LEFT);
				cell.setVerticalAlignment(ElementTags.ALIGN_TOP);
				aTable.addCell(cell); // 

				cell = new Cell(new Phrase((String) model.getValueAt(i, 3) , fonts)); // 
				cell.setHorizontalAlignment(ElementTags.ALIGN_LEFT);
				cell.setVerticalAlignment(ElementTags.ALIGN_TOP);
				aTable.addCell(cell); //@

				// JbgbvZ
				double Ir;
				StringBuilder strb = new StringBuilder();

				Ir = model.getSecond(i, SBDTableModel.SEC);
				if (Ir >= 0) {
					//setHorizontalAlignment(this.RIGHT);
					double s = Ir;
					int ss = (int) Ir;
					if (s - ss <= 0) {
						strb.append(ss).append( "b");
					} else {
						strb.append(Ir).append("b");
					}
				}

				int koma = model.getKoma(i, SBDTableModel.SEC);
				if (koma > 0) {
					if(strb.length()<=0l){
						strb.append(koma).append("");
					}else{
						strb.append(" + ").append( koma ).append( "" );
					}
				}
				cell = new Cell(new Phrase((String) strb.toString(), fontk))  ; // b
				aTable.addCell(cell); // b

				// vԌvZ
				double Fr;
				Fr = model.getSecond(i,5);
				strb = new StringBuilder();
				if (Fr >= 60) {
					int m = ((int) Fr) / 60;
					double s = Fr - m * 60;
					int ss = ((int) Fr) - m * 60;
					if (s - ss <= 0) {
						strb.append(" ").append(m).append("").append(ss).append("b");
					} else {
						strb.append(" ").append(m).append("").append( s).append( "b");
					}
				} else if (Fr >= 0) {
					double s = Fr;
					int ss = (int) Fr;
					if (s - ss <= 0.0) {
						strb.append( ss ).append("b");
						//logger.info("܂聁"+a);
					} else {
						strb.append( s).append( "b");
					}
				}
				koma = model.getKoma(i, 5);
				if (koma > 0) {
					strb.append(" + ").append( koma ).append( "");
				}
				cell = new Cell(new Phrase(strb.toString(), fontk)); // v
				aTable.addCell(cell); // v

				// vOXo[i߂
				try{
					prog = i;
					SwingUtilities.invokeLater(updateAComponent);
				}catch(Exception e){

				}
			}
			document.add(aTable);

		} catch (DocumentException de) {
			System.err.println(de.getMessage());
		} catch (IOException ioe) {
			System.err.println(ioe.getMessage());
		} catch (Exception e) {
			System.err.println(e.getMessage());
		}finally{
			/* hLgCLOSE */
			document.close();
		}
	}

	/**
	 * 傫߂C[W擾
	 * @param imgName t@C
	 * @param iconmode true:ʏ false:Ch
	 * @return k摜̃C[W
	 * @throws Exception
	 */
	private Image getScaledImage(String imgName) throws Exception {
		Image ret=null;
		// 2011/2/21 PDFfBNgzɏo͂悤ɉ
		//String newImgName =
		//	imgName.substring(0, imgName.lastIndexOf('.'))+"_PDF.png";

		File imgfile = new File(imgName);
		String tmpdir = imgfile.getParent();
		String tmpfile = imgfile.getName();
		String pdfdir = tmpdir+File.separator +"PDF";
		try{
			File pdfdirfile = new File(pdfdir);
			pdfdirfile.getCanonicalFile().mkdirs();
		}catch(Exception e){
			logger.warning("PDFo͗pfBNg("+pdfdir+")쐬s@"+e.getLocalizedMessage());
		}
		String newImgName = pdfdir+File.separator+tmpfile;

		logger.info("PDF File="+newImgName+" pdfpath="+pdfdir);

		int x,y;
		x = getBlankX();
		y = getBlankY();

		File imgFile = new File(imgName);
		// _PDF.pngɑ݂ĂΗpB
		File newImgFile = new File(newImgName);
		//logger.info("newImgFile.exists="+newImgFile.getAbsoluteFile().exists()  + " newModified="+newImgFile.getAbsoluteFile().lastModified() + " oldModified="+ imgFile.getAbsoluteFile().lastModified() );
		if(newImgFile.getAbsoluteFile().exists()){
			//logger.info("łɏkς݂");
			if( newImgFile.getAbsoluteFile().lastModified() >= imgFile.getAbsoluteFile().lastModified()  ){
				try{
					ret =  Image.getInstance(newImgName);
					if(  (ret.plainWidth()==x) && (ret.plainHeight()==y) ){
						logger.info("kKvȂ. x="+x+" plainWidth="+ret.plainWidth() );
						return ret;
					}
					// Ă͂܂ȂV쐬
				}catch(Exception e){
					logger.warning("kC[W擾쐬s:"+newImgName+" "+e.toString() );
				}
			}
		}

		// kĕۑ@iconmode true͒ʏ

		// ǂݍ
		//BufferedImage bf = ImageIO.read( imgFile.getAbsoluteFile() );
		BufferedImage bf;
		String ext = imgName.substring( imgName.lastIndexOf('.')+1 );
		if( ext.equalsIgnoreCase("png") || ext.equalsIgnoreCase("gif") || ext.equalsIgnoreCase("jpg") || ext.equalsIgnoreCase("jpeg") ){
            // ImageIOgƒxɃ[N邽߁APNG,GIF,JPEG awt.ToolKitgB
			java.awt.Image img = java.awt.Toolkit.getDefaultToolkit().getImage( imgFile.getCanonicalPath() );
			Point p = getImageSize(img);
			bf = new BufferedImage(p.x, p.y, BufferedImage.TYPE_3BYTE_BGR);  // BufferedImageIuWFNg쐬
			Graphics g = bf.createGraphics();  // Graphics̎擾
			g.drawImage(img,0,0,null);  // BufferedImageɕ`悳
       	}else{
	        File readImgFile = new File(imgName).getAbsoluteFile();
	    	ImageReader imgReader = (ImageReader)imageReaders.get( ext );
    		InputStream is = new FileInputStream( readImgFile );
    		imgReader.setInput(ImageIO.createImageInputStream(  is  ));
    		bf = imgReader.read(0);
    		is.close();
       	}

		// k
		BufferedImage newImg = new BufferedImage(x,y, BufferedImage.TYPE_INT_RGB);
		Graphics dstgr = newImg.createGraphics();
		dstgr.setColor( Color.WHITE );
		dstgr.fillRect(0,0, getBlankX(), getBlankY());
		dstgr.drawImage(bf.getScaledInstance(x, y, java.awt.Image.SCALE_SMOOTH)  ,0,0,null,null);
		// o
		ImageIO.write( newImg, "png", newImgFile.getCanonicalFile() );

		dstgr.dispose();
		dstgr = null;
		bf.flush();
		bf=null;
		newImg.flush();
		newImg=null;

		ret =  Image.getInstance(newImgName);
		return ret;
	}

	private Point getImageSize(java.awt.Image img) {
		java.awt.MediaTracker tracker = new java.awt.MediaTracker(dlg);
		tracker.addImage(img, 0);
		try {
			tracker.waitForID(0);
		} catch (InterruptedException e) {
		}
		return new Point(img.getWidth(null), img.getHeight(null));
	}

	/**
	 *
	 * ȉPDF,RTFňقȂ镔
	 */

	/**
	 * model.getIconMode() == SBDTableModel.ICON_WIDE
	 * āA󔒉摜̏c̑傫At@CԂB
	 * setTableWidthaTableɊeJ̔䗦ZbgB
	 */
	abstract int getBlankX();
	abstract int getBlankY();
	abstract String getBlankImageFileName();
	abstract void setTableWidth(Table aTable) throws Exception;
	abstract void getWriter( Document doc ) throws Exception;
}
