import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.ByteArrayInputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.LineNumberReader;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.Vector;

import javax.swing.DefaultListModel;

/**
 * @author t-saito
 *
 * Vertical Editorp@KwteLXg(ViI)ΉNX
 */
public class WzMemo {
	private SBDTableModel tbl;
	private DefaultListModel bookmarks;
	
	private static final String desc_checker = "";
	private static final String word_checker  = "uwimo([{";
	private static final String word_checker2= "vxjnp)]}";
	private static final String change_checker = "~";
	
	private static final double WORD_PASE = 0.15; // 1̕b 400/
	private static final int WORD_CUT = 27; // 䎌؂臒lB0.15*27=Sb

	public WzMemo( SBDTableModel p_tbl, DefaultListModel p_bookmarks ){
		tbl = p_tbl;
		bookmarks = p_bookmarks;
	}

	/**
	 * KwteLXgo
	 * @param filename
	 * @throws Exception
	 */
	public void write(String filename) throws Exception{
		// փobt@ɒǉĂB
		StringBuilder sb=new StringBuilder();
		BufferedWriter writer=new BufferedWriter(new FileWriter(filename));
		//BufferedWriter writer = new BufferedWriter(	new OutputStreamWriter( new FileOutputStream("filename"), "MS932"));

		/**
		 * mode 0:SNR(ViI`) @1:TXT(KwteLXg)
		 */
		int mode=-1;

		if (filename.indexOf(".snr") > 0 || filename.indexOf(".SNR") > 0) {
			mode = 0;
		}else{
			mode = 1;
		}
		
		if(bookmarks == null || bookmarks.size()<=0 ){
			// Ŗ{
			for (int i = tbl.getRowCount()-1; i >= 0 ; i--) {
				String desc = tbl.getValueAt(i, SBDTableModel.DESC).toString();
				String words=tbl.getValueAt(i, SBDTableModel.WORDS).toString();
				sb.insert(0,"\r\n");
				sb.insert(0,words);
				sb.insert(0,"\r\n");
				sb.insert(0,desc);
			}

			// 肪̂łƂ肠^Cg𒌂
			sb.insert(0,"\r\n");
			sb.insert(0,tbl.title);
			sb.insert(0,"");
			if(mode == 1){
				sb.insert(0, "\r\n" );
				sb.insert(0,tbl.title);
				sb.insert(0,".");
			}
		}else{
			int line = tbl.getRowCount()-1;
			// 
			for (int i = bookmarks.getSize()-1 ; i >=0 ; i--) {
				BookmarkItem item=(BookmarkItem)bookmarks.getElementAt(i);
				String key= deleteDot(item.key); //擪dottĂ菜
				String point = item.point;
				
				// pointƈvL[o܂Ŗ{
				while(line >= 0){
					String cmpkey = tbl.getValueAt(line,  SBDTableModel.KEY).toString();
					if(cmpkey.equalsIgnoreCase(point)){
						//System.out.println("BREAK");
						break;
					}else{
						//System.out.println("ADD"+line);
					}
					String desc = tbl.getValueAt(line,  SBDTableModel.DESC).toString();
					String words=tbl.getValueAt(line,  SBDTableModel.WORDS).toString();
					//System.out.println("desc="+desc+" word="+words);
					if(words != null && words.length() >0){
						sb.insert(0,"\r\n");
						sb.insert(0, addKakko(deleteCRLF(words)) );
					}
					if(desc != null && desc.length() >0){
						sb.insert(0,"\r\n");
						sb.insert(0, deleteCRLF(desc) );
					}
					line --;				
				}
				
				// 聁
				sb.insert(0,"\r\n");
				sb.insert(0,key);
				sb.insert(0,"");
				if(mode == 1){
					sb.insert(0, "\r\n");
					sb.insert(0,key);
					sb.insert(0,".");
				}
			}

			while(line >= 0){
				//String cmpkey = tbl.getValueAt(line,  SBDTableModel.KEY).toString();
				String desc = tbl.getValueAt(line,  SBDTableModel.DESC).toString();
				String words=tbl.getValueAt(line,  SBDTableModel.WORDS).toString();
				//System.out.println("desc="+desc+" word="+words);
				if(words != null && words.length() >0){
					sb.insert(0,"\r\n");
					sb.insert(0, addKakko(deleteCRLF(words)) );
				}
				if(desc != null && desc.length() >0){
					sb.insert(0,"\r\n");
					sb.insert(0, deleteCRLF(desc) );
				}
				line --;				
			}
			sb.insert(0,"\r\n");
			sb.insert(0,tbl.title);
			sb.insert(0,"");
			if(mode == 1){
				sb.insert(0, "\r\n" );
				sb.insert(0,tbl.title);
				sb.insert(0,".");
			}
		}
		try{
			writer.write(sb.toString());
			//System.out.println(sb);
		}catch(Exception e){
			e.printStackTrace();
			throw e;
		}finally{
			writer.flush();
			writer.close();
			sb = null;
		}
		return;
	}
	
	/**
	 * 񒆂CR,LFR[h@SpXy[X菜
	 * @param inp
	 * @return
	 */
	private String deleteCRLF(String inp){
		StringBuilder sb = new StringBuilder(inp);
		
		for(int i=sb.length()-1; i>=0; i--){
			char c = sb.charAt(i);
			if(Character.isISOControl(c))
				sb.deleteCharAt(i);
			
			if(c == '@')
				sb.deleteCharAt(i);
		}
		
		return sb.toString();
	}

	/**
	 * 䎌()JbR
	 * @param inp
	 * @return
	 */	
	private String addKakko(String inp){
		StringBuilder sb = new StringBuilder(inp);

		if(sb.indexOf("u") < 0){
			sb.insert(0,"u");
		}
		if(sb.indexOf("v") < 0){
			sb.append("v");
		}
		
		return sb.toString();
	}
	
	/**
	 * 擪.Ɓ菜(p)
	 * @param inp
	 * @return
	 */
	private String deleteDot(String inp){
		StringBuilder sb = new StringBuilder(inp);
		
		for(int i=0; i<sb.length();  i++){
			char c = sb.charAt(i);
			if(c == '.' || isScene(c)){
				sb.deleteCharAt(i);
			}else{
				break;
			}
		}
		
		return sb.toString();
	}

	/**
	 * KwteLXg(ViI)C|[gC
	 * @param filename
	 * @throws Exception
	 */
	public void read(String filename) throws Exception{
		String line; 
		BufferedReader bf = new BufferedReader( new FileReader( filename))	;
		int cutnum=1;
		int flg=-1;
		StringBuilder sb_words=null; // 䎌~ϗpobt@
		StringBuilder sb_desc = null; // gpobt@
		String bmk = null;
		boolean flg_bmk=false; // ubN}[N
		
		/**
		 * mode 0:SNR(ViI`) @1:TXT(KwteLXg)
		 */
		int mode=-1;

		if (filename.indexOf(".snr") > 0 || filename.indexOf(".SNR") > 0) {
			mode = 0;
		}else{
			mode = 1;
		}
		
		while( ( line = bf.readLine() ) != null ){
			//System.out.println("LINE="+line);
			if( line.length() <= 0 ){
				// s
			}else	if(line.charAt(0) == '.'){
				// w
				bmk = line;
				flg_bmk=true;
			}else if( isScene(line) || isChange(line)){
				//@
				//System.out.println("؂聗 desc="+sb_desc+" words="+sb_words);

				// w
				bmk = line;
				flg_bmk=true;

				if(sb_desc == null && sb_words == null){
				}else{
					if(flg_bmk){
						// ȂƂ̈ʒuPOɂ
						addRow(cutnum, sb_desc, sb_words, null); // ÕR[h
						flg_bmk=false;
					}else{
						addRow(cutnum, sb_desc, sb_words, bmk); // ÕR[h
						bmk = null;
					}
					sb_words = null;
					cutnum ++;
				}

				sb_desc = new StringBuilder();
				sb_desc.append(line);

				flg = SBDTableModel.KEY; //
			}else if(!isWords(line)){
				// 䎌ł͂Ȃ̂Ńg
				//System.out.println("g");
				
				if(flg != SBDTableModel.KEY){
					// ؂
					//System.out.println("؂聗g desc="+sb_desc+" words="+sb_words);
					if(flg_bmk){
						// ȂƂ̈ʒuPOɂ
						addRow(cutnum, sb_desc, sb_words, null); // ÕR[h
						flg_bmk=false;
					}else{
						addRow(cutnum, sb_desc, sb_words, bmk); // ÕR[h
						bmk=null;
					}
					sb_words = null;
					sb_desc = null;
					cutnum ++;
				}else{
					// ̌̃g
					if(sb_desc == null){
						sb_desc = new StringBuilder();
					}
					sb_desc.append("\r\n");
				}
				
				// ̐gɒǉ
				if(sb_desc == null){
					sb_desc = new StringBuilder();
				}
				sb_desc.append(line);
				
				flg = SBDTableModel.DESC; //
			}else{
				// ʂB䎌
				//System.out.println("䎌");
				
				// 27ȏiSbj𒴂U؂B
				if(sb_words != null && sb_words.length() > WORD_CUT){
					if(flg_bmk){
						// ȂƂ̈ʒuPOɂ
						addRow(cutnum, sb_desc, sb_words, null); // ÕR[h
						flg_bmk=false;
					}else{
						addRow(cutnum, sb_desc, sb_words, bmk); // ÕR[h
						bmk = null;
					}
					sb_words = null;
					cutnum ++;
				}

				if(flg == SBDTableModel.DESC){
					// g̎ɓo
					sb_words = new StringBuilder();
				}else if(flg == SBDTableModel.WORDS){
					if(sb_words == null){ 
						sb_words = new StringBuilder();
					}else{
						sb_words.append("\r\n");
					}
				}else{
					//`ɑ䎌o
					sb_words = new StringBuilder();
				}
				sb_words.append(line);
				
				flg = SBDTableModel.WORDS; //䎌
			}
		}
		addRow(cutnum, sb_desc, sb_words, bmk); // ÕR[h
		return;
	}

	/**
	 * sǉ
	 * @param row
	 * @param sb_desc
	 * @param sb_words
	 * @param bmk
	 */	
	private void addRow(int row, StringBuilder sb_desc, StringBuilder sb_words, String bmk){
		if(sb_desc == null && sb_words == null){
			return;
		}
		Object[] rec = new Object[SBDTableModel.COLMNNUMBERS];
		rec[SBDTableModel.CUT]= new Float(row);
		//rec[SBDTableModel.IMG]= new String("");
		rec[SBDTableModel.IMG]= "";
		if(sb_desc != null){
			rec[SBDTableModel.DESC] = sb_desc.toString();
		}else{
			rec[SBDTableModel.DESC] = "";
		}
		if(sb_words != null){
			rec[SBDTableModel.WORDS] = sb_words.toString();
		}else{
			rec[SBDTableModel.WORDS] = "";
		}
		/**
		if(sb_words!=null && sb_words.length()>2){
			//rec[SBDTableModel.SEC]= calcWordTime(sb_words);
			rec[SBDTableModel.SEC]= new String("");
		}else{
			rec[SBDTableModel.SEC]= new String("");
		}
		*/
		rec[SBDTableModel.SEC]= "";
		
		rec[SBDTableModel.KEY]= sbedit.makeKeyUID();
		//System.out.println("ADDcut="+rec[SBDTableModel.CUT]+" desc="+rec[SBDTableModel.DESC].toString()+" word="+rec[SBDTableModel.WORDS].toString());
		tbl.addRow(rec);
		
		// 肠 擪.͏Bbookmarksnull͗L蓾ȂB
		if(bmk != null){
			BookmarkItem itm = new BookmarkItem(deleteDot(bmk), (String)rec[SBDTableModel.KEY]);
			bookmarks.addElement(itm);
		}
	}
	
	/**
	 * sȂtrue
	 * @return
	 */
	private boolean isScene( String line){
		if( desc_checker.indexOf(line.charAt(0)) >= 0 ){
			//System.out.println("Scene true");
			return true;
		}
		//System.out.println("Scene false ");
		return false;
	}
	
	/**
	 * sȂtrue
	 * @return
	 */
	private boolean isScene( char c){
		if( desc_checker.indexOf(c) >= 0 ){
			//System.out.println("Scene true");
			return true;
		}
		//System.out.println("Scene false ");
		return false;
	}
	
	
	/**
	 * s䎌Ȃtrue
	 * @param line
	 * @return
	 */
	private boolean isWords(String line){
		for(int i=0; i<word_checker.length(); i++){
			if( line.indexOf(word_checker.charAt(i)) >= 0 ){
				//System.out.println("Words true");
				return true;
			}
		}
		
		//System.out.println("Words false ");
		return false;
		
	}
	
	/**
	 * sω(~@~@~)Ȃtrue
	 * @param line
	 * @return
	 */
	private boolean isChange(String line){
		for(int i=0; i<change_checker.length(); i++){
			if( line.indexOf(change_checker.charAt(i)) >= 0 ){
				//System.out.println("Change true");
				return true;
			}
		}
		
		//System.out.println("Change false ");
		return false;
		
	}
	
	/**
	 * Jbg̎Ԑݒ
	 *
	 */
	public void calcTimes(){

		int notcut=0; // ԕs̃Jbg
		int nolength = 0; //ԕs̑
		for (int i = 0; i < tbl.getRowCount(); i++) {
			Object o = tbl.getValueAt(i, SBDTableModel.SEC);
			if(o != null && o.getClass().getName().equalsIgnoreCase("java.lang.Double")){
			}else{
				// Ԏw肪Jbg
				String words = (String)tbl.getValueAt(i,SBDTableModel.WORDS);
				if(words != null && words.length()>2){
					// 䎌΁A玞Ԋo
					tbl.setValueAt(calcWordTime(words), i , SBDTableModel.SEC ); // 1/10
				}else{
					String desc = (String)tbl.getValueAt(i, SBDTableModel.DESC);
					if(desc != null){
						nolength += desc.length();
					}
					notcut++;
				}
			}
		}
		double totalsec = notcut *4; // {1JbgSb
		double charsec = totalsec / nolength; //g1̕b
		System.out.println("notcut="+notcut+" nolength="+nolength+" totalsec="+totalsec+" charsec="+charsec);
		for (int i = 0; i < tbl.getRowCount(); i++) {
			Object o = tbl.getValueAt(i, SBDTableModel.SEC);
			if(o != null && o.getClass().getName().equalsIgnoreCase("java.lang.Double")){
			}else{
				// Ԏw肪Jbg
				String desc = (String)tbl.getValueAt(i, SBDTableModel.DESC);
				if(desc != null&&desc.length()>0){
					double mysec = (int)((desc.length() * charsec) *10); // 10{
					mysec += 0.5;
					mysec /=10; // 1/10
					tbl.setValueAt(new Double(mysec), i, SBDTableModel.SEC);
				}
				//else{
				//	tbl.setValueAt(new Double(4), i,  SBDTableModel.SEC);
				//}
			}
		}			
	}

	/**
	 * @䎌ԂvZB
	 */
	private Double calcWordTime(StringBuilder sb){
		return calcWordTime(sb.toString());
	}	
	private Double calcWordTime(String words){
		double d;
		//d = (( words.toString().length() -2 ) * WORD_PASE) * 10; //10{
		d = (countWords(words) * WORD_PASE) * 10; //10{
		double iv = (int)(d+0.5); //ľܓ
		//System.out.println("d="+d+" iv="+iv);
		double  ret = iv/10; // 1/10
		
		// ucvPɂ1.5bǉ
		int i=0;
		while((i=words.indexOf("c",i)) > 0){
			ret = ret+1.5;
			System.out.println("i="+i);
			i++;
		}
		// u[vPɂ1bǉ
		i=0;
		while((i=words.indexOf("[",i)) > 0){
			ret = ret+1.5;
			System.out.println("i="+i);
			i++;
		}

		return new Double(ret);
	}
	
	/**
	 * uv̒̕𐔂.sΉ
	 * @param words
	 * @return
	 */
	private int countWords(String words){
		System.out.println("countWords."+words);
		int ret = 0;
		try{
			InputStream is  = new ByteArrayInputStream( words.getBytes());
			LineNumberReader lnr =
				new LineNumberReader(new InputStreamReader(is));
			String line = lnr.readLine();
			while (line != null) {
				ret += countWordsLine(line);
				//System.out.println("line="+line+"ret="+ret);
				line = lnr.readLine();
			}
			is.close();
			lnr.close();
		}catch(Exception e){
			e.printStackTrace();
		}finally{
		}

		return ret;
	}
	private int countWordsLine(String words){
		//System.out.println("countWordsLine."+words);
		if(words == null){
			return -1;
		}
		words = deleteCRLF(words); // s폜
		int ret=words.length();
		int point=0;
		if(isWords(words) == false){
			// ʖ
			return ret;
		}else{
			// 擪̘b҂XLbv
			int i;			
			for(i=0; i<words.length(); i++){
				ret --;
				if(isKakko(words.charAt(i))){
					break;
				}
			}
			if(i>=words.length()){
				return ret;
			}
			point =i+1;
		}
		
		String sub = words.substring(point);
		for(int i=0; i<sub.length(); i++){
			if(isKakko(sub.charAt(i))){
				//System.out.println(""+sub.charAt(i)+" ̂Ƃ"+ret);
				ret --;
			}
		}
		
		//System.out.println(""+words+" "+ret);
		return ret;
	}

	/**
	 * ʂȂtrue;
	 * @param c
	 * @return
	 */	
	private boolean isKakko(char c){
		if(word_checker.indexOf(c) >= 0){
			return true;
		}
		if(word_checker2.indexOf(c) >= 0){
			return true;
		}
		return false;
	}

	/**
	 * ʂȂtrue;
	 * @param c
	 * @return
	 */	
	private boolean isKakko2(char c){
		if(word_checker.indexOf(c) >= 0){
			return true;
		}
		return false;
	}
	
	/**
	 * ҕs̔XgAbv
	 * @return
	 */
	public ArrayList<Integer> checkWords(){
		CharacterTableModel charList = tbl.getCharList();
		Vector v = charList.getDataVector();
		ArrayList<Integer> ret=new ArrayList<Integer>();
		for(int i=0; i<tbl.getRowCount(); i++){
			String words = (String)tbl.getValueAt(i, SBDTableModel.WORDS);
			if(words != null && words.length() > 0){
				if(isWords(words)==false ){
					// ʂ
					tbl.setValueAt( addKakko(words), i, SBDTableModel.WORDS);
					ret.add( Integer.valueOf(i));
				}else{
					String name = getName(words);
					if(name != null && name.length()>0){
						// O
						System.out.println("ol="+name);
						// d`FbN
						boolean newflg = true;
						Iterator it = v.iterator();
						while(it.hasNext()){
							try{
								Vector vv = (Vector)it.next();
								String n = (String)vv.get(CharacterTableModel.NAME);
								System.out.println("VV="+vv+" name="+n);
								if(n.equalsIgnoreCase(name)){
									System.out.println("d"+name);
									newflg = false;
									break;
								}else{
									System.out.println("o?"+name);
								}
							}catch(Exception e){
								e.printStackTrace();
								System.out.println("OF"+name);
							}
						}
						if(newflg){
							Object[] rec = new Object[CharacterTableModel.COLMNNUMBERS];
							//rec[CharacterTableModel.NAME] = new String(name); // FindBugsɂB
							rec[CharacterTableModel.NAME] = name;
							rec[CharacterTableModel.SEX] =  "S";
							rec[CharacterTableModel.AGE] = "A";
							rec[CharacterTableModel.DESC] = "D";
							rec[CharacterTableModel.IMG] = "I";
							rec[CharacterTableModel.KEY] = sbedit.makeKeyUID();
							System.out.println("rec="+rec.length);
							charList.addRow(rec);
						}
						
					}else{
						// OȂ
						ret.add( Integer.valueOf(i));
					}
				}
			}
		}
		System.out.println("l"+charList.getRowCount()  );
		
		return ret;
	}
	
	/**
	 * ҂̖OԂ
	 * @param words
	 * @return
	 */
	private String getName(String words){
		StringBuilder ret = new StringBuilder();
		int i;
		boolean flg=false;
		for(i=0; i<words.length(); i++){
			if(Character.isISOControl(words.charAt(i))){
				//System.out.println("ȂsF"+words);
				break;
			}
			if( isKakko2(words.charAt(i)) == false){
				ret.append(words.charAt(i));
				//try{
				//	ret.append(words.charAt(i));
				//}catch(IOException e){
				//}
			}else{
				flg = true;
				//System.out.println("JbRF"+words);
				break;
			}
		}
		if(flg == false){
			return null; 
		}
		// u̐v炻͍
		String ret2 = ret.toString();
		int koe=ret2.indexOf("̐");
		if(koe > 0){
			ret2 = ret2.substring(0, koe);
		}
		return ret2.trim();
	}
}
