import java.io.File;
import java.io.FileOutputStream;
import java.util.Hashtable;

import javax.imageio.ImageReader;

import com.lowagie.text.Document;
import com.lowagie.text.Table;
import com.lowagie.text.pdf.PdfWriter;

/*
 * Created on 2006/02/15
 *
 * oceo͏
 * {̂MakeiTextTempQ
 */

/**
 * @author Administrator
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class MakePDF extends MakeiTextTemp {
	/**
	 * @param p_filename
	 * @param p_path
	 * @param p_model
	 * @param p_dlg
	 * @param p_dfont
	 * @param p_sfont
	 */
	MakePDF(String p_filename,  String p_path, SBDTableModel p_model, DialogProgress p_dlg,  java.awt.Font p_dfont, java.awt.Font p_sfont, Hashtable<String, ImageReader> p_imageReaders) {
		super( p_filename,  p_path,  p_model, p_dlg, p_dfont,p_sfont, p_imageReaders  );
	}

	/* (non-Javadoc)
	 * @see MakeiTextTemp#getBlankX()
	 */
	@Override
	int getBlankX(){
		return 640;
	}

	/* (non-Javadoc)
	 * @see MakeiTextTemp#getBlankY()
	 */
	@Override
	int getBlankY(){
		if(model.getIconMode() == SBDTableModel.ICON_WIDE){
			return 360;
		}else{
			return 480;
		}
	}

	/* (non-Javadoc)
	 * @see MakeiTextTemp#getBlankImageFileName()
	 */
	@Override
	String getBlankImageFileName(){
		String blankimage;
		if(model.getIconMode() == SBDTableModel.ICON_WIDE){
			blankimage =
				execPath
					+ File.separator
					+ "img"
					+ File.separator
					+ "640_360.png";
		}else{
			blankimage =
				execPath
					+ File.separator
					+ "img"
					+ File.separator
					+ "640_480.png";
		}
		return blankimage;
	}

	/* (non-Javadoc)
	 * @see MakeiTextTemp#setTableWidth(com.lowagie.text.Table)
	 */
	@Override
	void setTableWidth(Table aTable) throws Exception{
		int width[] = { 5, 40, 23, 22, 5, 5  };; // JbgmCGAAAbAv@̔䗦BvPOOɂȂ悤ɁB
		aTable.setWidths(width); // eJ̑傫ݒip[Zgj
		if(model.getIconMode() == SBDTableModel.ICON_WIDE){
			// Ch
			aTable.setWidth((float)99.5); // e[uŜ̑傫ݒip[Zgj@ōs
		}else{
			// m[}
			aTable.setWidth( (float)90.8 ); // e[uŜ̑傫ݒip[Zgj
		}
	}

	/**
	 * 
	 */
	@Override
	void getWriter(Document doc)  throws Exception{
		PdfWriter.getInstance(doc,  new FileOutputStream(fileName));
	}

}
